package com.example.tfg_bueno

import android.content.Intent
import android.media.MediaPlayer
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseReference
import com.google.firebase.database.FirebaseDatabase
import kotlinx.android.synthetic.main.activity_configuracion.*
import kotlinx.android.synthetic.main.activity_configuracion.background
import kotlinx.android.synthetic.main.activity_configuracion.home_img2
import kotlinx.android.synthetic.main.activity_configuracion.home_img4
import kotlinx.android.synthetic.main.activity_configuracion.home_img5
import kotlinx.android.synthetic.main.activity_configuracion.menu
import kotlinx.android.synthetic.main.activity_principal.*


class Configuracion : AppCompatActivity() {

    private lateinit var database: FirebaseDatabase
    private lateinit var mDatabase: DatabaseReference
    private lateinit var auth: FirebaseAuth


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_configuracion)
        database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
        mDatabase = database.getReference()
        auth = FirebaseAuth.getInstance()

        val uid = auth.currentUser?.uid

        home_img2.setOnClickListener{
            if(switch2.isChecked){
                val mediaPlayer = MediaPlayer.create(this, R.raw.boton_inicio)
                mediaPlayer.start()
            }
            val i = Intent(this,Principal::class.java)
            startActivity(i)
            finish()
        }

        home_img4.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_cerrarsesion)
                    mediaPlayer.start()
                }

            }
            FirebaseAuth.getInstance().signOut()
            val i = Intent(this,MainActivity::class.java)
            startActivity(i)
            finish()
        }

        home_img5.setOnClickListener{
            if(switch2.isChecked){
                val mediaPlayer = MediaPlayer.create(this, R.raw.boton_miperfil)
                mediaPlayer.start()
            }
            val i = Intent(this,MiPerfil::class.java)
            startActivity(i)
            finish()
        }

        database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
        mDatabase = database.getReference()
        auth = FirebaseAuth.getInstance()


        settext(uid)

        switch4.setOnClickListener {
            if(switch4.isChecked){
                if(switch2.isChecked){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.texto_normal)
                    mediaPlayer.start()
                }
                switch5.isChecked = false
                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    mDatabase.child("user").child(uid!!).child("acc_text").setValue("false")
                }

                switch4.setTextSize(15F)
                switch5.setTextSize(15F)
                switch2.setTextSize(15F)
                switch3.setTextSize(15F)
            }else{
                if(switch2.isChecked){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.texto_grande)
                    mediaPlayer.start()
                }
                switch5.isChecked = true
                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    mDatabase.child("user").child(uid!!).child("acc_text").setValue("true")
                }
                switch4.setTextSize(23F)
                switch5.setTextSize(23F)
                switch2.setTextSize(23F)
                switch3.setTextSize(23F)
            }
        }

        switch5.setOnClickListener {
            if(switch5.isChecked){
                if(switch2.isChecked){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.texto_grande)
                    mediaPlayer.start()
                }
                switch4.isChecked = false
                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    mDatabase.child("user").child(uid!!).child("acc_text").setValue("true")
                }

                switch4.setTextSize(23F)
                switch5.setTextSize(23F)
                switch2.setTextSize(23F)
                switch3.setTextSize(23F)
            }else{
                if(switch2.isChecked){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.texto_normal)
                    mediaPlayer.start()
                }
                switch4.isChecked = true
                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    mDatabase.child("user").child(uid!!).child("acc_text").setValue("false")
                }

                switch4.setTextSize(15F)
                switch5.setTextSize(15F)
                switch2.setTextSize(15F)
                switch3.setTextSize(15F)
            }
        }


        switch2.setOnClickListener {
            if(switch2.isChecked){
                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    mDatabase.child("user").child(uid!!).child("dalt_mode").setValue("true")
                    val mediaPlayer = MediaPlayer.create(this, R.raw.modo_voz)
                    mediaPlayer.start()
                }
            }else{
                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    mDatabase.child("user").child(uid!!).child("dalt_mode").setValue("false")
                }
            }
        }


        switch3.setOnClickListener {
            if(switch3.isChecked){
                if(switch2.isChecked){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.modo_bw)
                    mediaPlayer.start()
                }
                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    mDatabase.child("user").child(uid!!).child("bw_mode").setValue("true")
                }

                background.setBackgroundResource(R.drawable.background_bw)

                switch2.setTextColor(resources.getColor(R.color.black))
                switch3.setTextColor(resources.getColor(R.color.black))
                switch4.setTextColor(resources.getColor(R.color.black))
                switch5.setTextColor(resources.getColor(R.color.black))

                menu.setBackgroundColor(resources.getColor(R.color.black))



            }else{
                if(switch2.isChecked){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.modo_bw_desactivado)
                    mediaPlayer.start()
                }
                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    mDatabase.child("user").child(uid!!).child("bw_mode").setValue("false")
                }

                background.setBackgroundResource(R.drawable.background)

                switch2.setTextColor(resources.getColor(R.color.white))
                switch3.setTextColor(resources.getColor(R.color.white))
                switch4.setTextColor(resources.getColor(R.color.white))
                switch5.setTextColor(resources.getColor(R.color.white))

                menu.setBackgroundColor(resources.getColor(R.color.menucolor))

            }
        }



    }

    private fun settext(uid: String?) {
        mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
            var result = "false"
            var byw = "false"
            var voz ="false"
            for (ds: DataSnapshot in it.children) {

                if(ds.key.toString()=="acc_text"){
                    result =ds.value.toString()
                }

                if(ds.key.toString()=="bw_mode"){
                    byw =ds.value.toString()
                }

                if(ds.key.toString()=="dalt_mode"){
                    voz =ds.value.toString()
                }
            }

            if(voz=="true"){
                switch2.isChecked=true
            }
            if(result=="true"){

                switch5.isChecked=true

                switch4.setTextSize(23F)
                switch5.setTextSize(23F)
                switch2.setTextSize(23F)
                switch3.setTextSize(23F)
            }else{

                switch4.isChecked=true
                switch4.setTextSize(15F)
                switch5.setTextSize(15F)
                switch2.setTextSize(15F)
                switch3.setTextSize(15F)
            }

            if(byw=="true"){
                background.setBackgroundResource(R.drawable.background_bw)

                switch3.isChecked=true

                switch2.setTextColor(resources.getColor(R.color.black))
                switch3.setTextColor(resources.getColor(R.color.black))
                switch4.setTextColor(resources.getColor(R.color.black))
                switch5.setTextColor(resources.getColor(R.color.black))


                menu.setBackgroundColor(resources.getColor(R.color.black))
            }



        }
    }
}