package com.example.tfg_bueno

import android.content.Intent
import android.media.MediaPlayer
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.TypedValue
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseReference
import com.google.firebase.database.FirebaseDatabase
import kotlinx.android.synthetic.main.activity_detalles_actividades.*
import kotlinx.android.synthetic.main.activity_detalles_actividades.background
import kotlinx.android.synthetic.main.activity_detalles_actividades.home_img2
import kotlinx.android.synthetic.main.activity_detalles_actividades.home_img3
import kotlinx.android.synthetic.main.activity_detalles_actividades.home_img4
import kotlinx.android.synthetic.main.activity_detalles_actividades.home_img5
import kotlinx.android.synthetic.main.activity_detalles_actividades.menu
import kotlinx.android.synthetic.main.activity_principal.*


class DetallesActividades : AppCompatActivity() {

    private lateinit var database: FirebaseDatabase
    private lateinit var mDatabase: DatabaseReference
    private lateinit var auth: FirebaseAuth

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_detalles_actividades)
        database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
        mDatabase = database.getReference()
        auth = FirebaseAuth.getInstance()

        val uid = auth.currentUser?.uid


        home_img2.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_inicio)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,Principal::class.java)
            startActivity(i)
            finish()
        }

        home_img3.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_accesibilidad)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,Configuracion::class.java)
            startActivity(i)
            finish()
        }

        home_img4.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_cerrarsesion)
                    mediaPlayer.start()
                }

            }
            FirebaseAuth.getInstance().signOut()
            val i = Intent(this,MainActivity::class.java)
            startActivity(i)
            finish()
        }

        home_img5.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_miperfil)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,MiPerfil::class.java)
            startActivity(i)
            finish()
        }



        val deporte = intent.getStringExtra("deporte")
        val dia = intent.getStringExtra("dia")
        val hora = intent.getStringExtra("hora")
        val pista = intent.getStringExtra("pista")
        val personas = intent.getStringExtra("personas")
        val actividad = intent.getStringExtra("actividad")


        deporte_id.text=deporte
        dia_id.text=dia
        hora_id.text=hora
        pista_id.text=pista
        personas_id.text=personas


        mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
            var byw = "false"
            for (ds: DataSnapshot in it.children) {

                if(ds.key.toString()=="bw_mode"){
                    byw =ds.value.toString()
                }
            }

            if(byw=="true"){
                if(deporte=="Futbol") {
                    imagen.setBackgroundResource(R.drawable.field_bw)
                }else if(deporte=="Padel"){
                    imagen.setBackgroundResource(R.drawable.padel_bw)
                }else if(deporte=="Tennis"){
                    imagen.setBackgroundResource(R.drawable.tennis_bw)
                }else{
                    imagen.setBackgroundResource(R.drawable.baloncesto_bw)
                }
            }else{
                if(deporte=="Futbol") {
                    imagen.setBackgroundResource(R.drawable.field)
                }else if(deporte=="Padel"){
                    imagen.setBackgroundResource(R.drawable.padel)
                }else if(deporte=="Tennis"){
                    imagen.setBackgroundResource(R.drawable.tennis)
                }else{
                    imagen.setBackgroundResource(R.drawable.baloncesto)
                }
            }

        }


         but_sign_in.setOnClickListener(){
            val reserva = Reserva(deporte!!,dia!!,hora!!,pista!!, personas!!,"true")
             mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                 var voz = "false"
                 for (ds: DataSnapshot in it.children) {

                     if(ds.key.toString()=="dalt_mode"){
                         voz =ds.value.toString()
                     }
                 }

                 if(voz=="true"){
                     val mediaPlayer = MediaPlayer.create(this, R.raw.boton_apuntarse)
                     mediaPlayer.start()
                 }

             }

            database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
            mDatabase = database.getReference()
            auth = FirebaseAuth.getInstance()

            val uid = auth.currentUser?.uid

            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                mDatabase.child("user").child(uid!!).child("reservas").child(deporte.toString()+dia.toString()+hora.toString()+pista.toString()).setValue(reserva)

            }

            val i = Intent(this,Principal::class.java)
            startActivity(i)
             finish()
        }


        mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
            var acctext = "false"
            var byw = "false"
            for (ds: DataSnapshot in it.children) {

                if(ds.key.toString()=="acc_text"){
                    acctext =ds.value.toString()
                }

                if(ds.key.toString()=="bw_mode"){
                    byw =ds.value.toString()
                }
            }

            if(acctext=="false"){
                textdeporte.setTextSize(13F)
                textdia.setTextSize(13F)
                texthora.setTextSize(13F)
                textpersonas.setTextSize(13F)
                textpista.setTextSize(13F)

                deporte_id.setTextSize(15F)
                dia_id.setTextSize(15F)
                hora_id.setTextSize(15F)
                pista_id.setTextSize(15F)
                personas_id.setTextSize(15F)

                but_sign_in.setTextSize(15F)

            }else{
                textdeporte.setTextSize(18F)
                textdia.setTextSize(18F)
                texthora.setTextSize(18F)
                textpersonas.setTextSize(18F)
                textpista.setTextSize(18F)

                deporte_id.setTextSize(23F)
                dia_id.setTextSize(23F)
                hora_id.setTextSize(23F)
                pista_id.setTextSize(23F)
                personas_id.setTextSize(23F)

                but_sign_in.setTextSize(23F)

            }

            if(byw=="true"){

                background.setBackgroundResource(R.drawable.background_bw)

                textdeporte.setTextColor(resources.getColor(R.color.black))
                textdia.setTextColor(resources.getColor(R.color.black))
                texthora.setTextColor(resources.getColor(R.color.black))
                textpersonas.setTextColor(resources.getColor(R.color.black))
                textpista.setTextColor(resources.getColor(R.color.black))

                deporte_id.setTextColor(resources.getColor(R.color.black))
                dia_id.setTextColor(resources.getColor(R.color.black))
                hora_id.setTextColor(resources.getColor(R.color.black))
                pista_id.setTextColor(resources.getColor(R.color.black))
                personas_id.setTextColor(resources.getColor(R.color.black))

                but_sign_in.setTextColor(resources.getColor(R.color.white))
                but_sign_in.setBackgroundColor(resources.getColor(R.color.black))


                menu.setBackgroundColor(resources.getColor(R.color.black))
            }

        }



    }
}