package com.example.tfg_bueno

import android.content.Intent
import android.media.MediaPlayer
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.TypedValue
import androidx.core.view.isVisible
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseReference
import com.google.firebase.database.FirebaseDatabase
import kotlinx.android.synthetic.main.activity_detalles_reservas.*
import kotlinx.android.synthetic.main.activity_detalles_reservas.background
import kotlinx.android.synthetic.main.activity_detalles_reservas.home_img2
import kotlinx.android.synthetic.main.activity_detalles_reservas.home_img3
import kotlinx.android.synthetic.main.activity_detalles_reservas.home_img4
import kotlinx.android.synthetic.main.activity_detalles_reservas.home_img5
import kotlinx.android.synthetic.main.activity_detalles_reservas.menu
import kotlinx.android.synthetic.main.activity_principal.*


class DetallesReservas : AppCompatActivity() {

    private lateinit var database: FirebaseDatabase
    private lateinit var mDatabase: DatabaseReference
    private lateinit var auth: FirebaseAuth


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_detalles_reservas)

        database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
        mDatabase = database.getReference()
        auth = FirebaseAuth.getInstance()

        val uid = auth.currentUser?.uid

        var id_pista: Int =0


        home_img2.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_inicio)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,Principal::class.java)
            startActivity(i)
            finish()
        }

        home_img3.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_accesibilidad)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,Configuracion::class.java)
            startActivity(i)
            finish()
        }

        home_img4.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_cerrarsesion)
                    mediaPlayer.start()
                }

            }
            FirebaseAuth.getInstance().signOut()
            val i = Intent(this,MainActivity::class.java)
            startActivity(i)
            finish()
        }

        home_img5.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_miperfil)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,MiPerfil::class.java)
            startActivity(i)
            finish()
        }

        val deporte = intent.getStringExtra("deporte")
        val dia = intent.getStringExtra("dia")
        val hora = intent.getStringExtra("hora")
        val pista = intent.getStringExtra("pista")
        val personas = intent.getStringExtra("personas")
        val actividad = intent.getStringExtra("actividad")


        deporte_id.text=deporte
        dia_id.text=dia
        hora_id.text=hora
        pista_id.text=pista


        mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
            var byw = "false"
            for (ds: DataSnapshot in it.children) {

                if(ds.key.toString()=="bw_mode"){
                    byw =ds.value.toString()
                }
            }

            if(byw=="true"){
                if(deporte=="Futbol") {
                    imagen.setBackgroundResource(R.drawable.field_bw)
                }else if(deporte=="Padel"){
                    imagen.setBackgroundResource(R.drawable.padel_bw)
                }else if(deporte=="Tennis"){
                    imagen.setBackgroundResource(R.drawable.tennis_bw)
                }else{
                    imagen.setBackgroundResource(R.drawable.baloncesto_bw)
                }
            }else{
                if(deporte=="Futbol") {
                    imagen.setBackgroundResource(R.drawable.field)
                }else if(deporte=="Padel"){
                    imagen.setBackgroundResource(R.drawable.padel)
                }else if(deporte=="Tennis"){
                    imagen.setBackgroundResource(R.drawable.tennis)
                }else{
                    imagen.setBackgroundResource(R.drawable.baloncesto)
                }
            }

        }


        if(actividad.equals("true")) {
            parentpersonaid.text = "Participantes"
            personas_id.text = personas
            but_sign_in.isVisible = false
            but_sign_in2.isVisible = true
            
        }else{
            parentpersonaid.text = "Personas"
            personas_id.text = personas
            but_sign_in.isVisible = true
            but_sign_in2.isVisible = false
            
        }

        if(pista == "Pista 1") {id_pista=0}
        if(pista == "Pista 2") {id_pista=1}
        if(pista == "Pista 3") {id_pista=2}
        if(pista == "Pista 4") {id_pista=3}
        if(pista == "Pista 5") {id_pista=4}

        but_sign_in.setOnClickListener(){
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_eliminarreserva)
                    mediaPlayer.start()
                }

            }
            val id = getid(hora)
            database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
            mDatabase = database.getReference()
            auth = FirebaseAuth.getInstance()

            val uid = auth.currentUser?.uid

            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                mDatabase.child("user").child(uid!!).child("reservas").child(deporte.toString()+dia.toString()+hora.toString()+pista.toString()).removeValue()

            }

            mDatabase.child("CalendarioReservas").child(dia.toString()).get().addOnSuccessListener {
                mDatabase.child("CalendarioReservas").child(dia.toString()).child(deporte.toString()).child("pistas").child(id_pista.toString()).child("reservadas").child(id.toString()).setValue("false")
            }

            val i = Intent(this,Principal::class.java)
            startActivity(i)
            finish()
        }

        but_sign_in2.setOnClickListener(){
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_desapuntarse)
                    mediaPlayer.start()
                }

            }
            database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
            mDatabase = database.getReference()
            auth = FirebaseAuth.getInstance()

            val uid = auth.currentUser?.uid

            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                mDatabase.child("user").child(uid!!).child("reservas").child(deporte.toString()+dia.toString()+hora.toString()+pista.toString()).removeValue()

            }


            val i = Intent(this,Principal::class.java)
            startActivity(i)
            finish()
        }

        mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
            var acctext = "false"
            var byw = "false"
            for (ds: DataSnapshot in it.children) {

                if(ds.key.toString()=="acc_text"){
                    acctext =ds.value.toString()
                }

                if(ds.key.toString()=="bw_mode"){
                    byw =ds.value.toString()
                }
            }

            if(acctext=="false"){
                textdeporte.setTextSize(13F)
                textdia.setTextSize(13F)
                texthora.setTextSize(13F)
                parentpersonaid.setTextSize(13F)
                textpista.setTextSize(13F)

                deporte_id.setTextSize(15F)
                dia_id.setTextSize(15F)
                hora_id.setTextSize(15F)
                pista_id.setTextSize(15F)
                personas_id.setTextSize(15F)

                but_sign_in2.setTextSize(15F)
                but_sign_in.setTextSize(15F)

            }else{
                textdeporte.setTextSize(18F)
                textdia.setTextSize(18F)
                texthora.setTextSize(18F)
                parentpersonaid.setTextSize(18F)
                textpista.setTextSize(18F)

                deporte_id.setTextSize(23F)
                dia_id.setTextSize(23F)
                hora_id.setTextSize(23F)
                pista_id.setTextSize(23F)
                personas_id.setTextSize(23F)

                but_sign_in2.setTextSize(23F)
                but_sign_in.setTextSize(23F)

            }

            if(byw=="true"){

                background.setBackgroundResource(R.drawable.background_bw)

                textdeporte.setTextColor(resources.getColor(R.color.black))
                textdia.setTextColor(resources.getColor(R.color.black))
                texthora.setTextColor(resources.getColor(R.color.black))
                parentpersonaid.setTextColor(resources.getColor(R.color.black))
                textpista.setTextColor(resources.getColor(R.color.black))

                deporte_id.setTextColor(resources.getColor(R.color.black))
                dia_id.setTextColor(resources.getColor(R.color.black))
                hora_id.setTextColor(resources.getColor(R.color.black))
                pista_id.setTextColor(resources.getColor(R.color.black))
                personas_id.setTextColor(resources.getColor(R.color.black))

                but_sign_in2.setTextColor(resources.getColor(R.color.white))
                but_sign_in.setTextColor(resources.getColor(R.color.white))

                but_sign_in2.setBackgroundColor(resources.getColor(R.color.black))
                but_sign_in.setBackgroundColor(resources.getColor(R.color.black))


                menu.setBackgroundColor(resources.getColor(R.color.black))
            }

        }







    }

    private fun getid(hora: String?): Int {
        when (hora) {
            "8:00h" -> return 0
            "9:00h" -> return 1
            "10:00h" ->return 2
            "11:00h" -> return 3
            "12:00h" -> return 4
            "13:00h" -> return 5
            "14:00h" -> return 6
            "15:00h" -> return 7
            "16:00h" -> return 8
            "17:00h" -> return 9
            "18:00h" -> return 10
            "19:00h" -> return 11
            "20:00h" -> return 12

            "21:00h" -> return 13
            else -> { // Note the block
                return 0
            }

    }


}}