package com.example.tfg_bueno

import android.content.Intent
import android.media.MediaPlayer
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.TypedValue
import android.widget.Button
import android.widget.LinearLayout
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseReference
import com.google.firebase.database.FirebaseDatabase
import kotlinx.android.synthetic.main.activity_mi_perfil.*


class MiPerfil : AppCompatActivity() {

    private lateinit var database: FirebaseDatabase
    private lateinit var mDatabase: DatabaseReference
    private lateinit var auth: FirebaseAuth


    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_mi_perfil)

        database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
        mDatabase = database.getReference()
        auth = FirebaseAuth.getInstance()

        val uid = auth.currentUser?.uid
        mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
            var acctext = "false"
            var byw ="false"
            for (ds: DataSnapshot in it.children) {

                if(ds.key.toString()=="acc_text"){
                    acctext =ds.value.toString()
                }

                if(ds.key.toString()=="bw_mode"){
                    byw =ds.value.toString()
                }
            }

            if(acctext=="false"){
                text_deporte.textSize = 13F
                text_email.setTextSize(13F)
                text_instagram.setTextSize(13F)
                text_twitter.setTextSize(13F)

                textview_deportes.setTextSize(15F)
                textview_email.setTextSize(15F)
                textview_facebook.setTextSize(15F)
                textview_twitter.textSize = 15F

                but_sign_in.setTextSize(TypedValue.COMPLEX_UNIT_SP,15F)

            }else{
                text_deporte.textSize = 18F
                text_email.setTextSize(18F)
                text_instagram.setTextSize(18F)
                text_twitter.setTextSize(18F)

                textview_deportes.setTextSize(23F)
                textview_email.setTextSize(23F)
                textview_facebook.setTextSize(23F)
                textview_twitter.textSize = 23F

                but_sign_in.setTextSize(TypedValue.COMPLEX_UNIT_SP,23F)
            }

            if(byw=="true"){

                rellay1.setBackgroundColor(resources.getColor(R.color.backk))
                backgroundd.setBackgroundResource(R.drawable.background_bw)

                tv_name.setTextColor(resources.getColor(R.color.black))

                text_deporte.setTextColor(resources.getColor(R.color.black))
                text_email.setTextColor(resources.getColor(R.color.black))
                text_instagram.setTextColor(resources.getColor(R.color.black))
                text_twitter.setTextColor(resources.getColor(R.color.black))

                textview_deportes.setTextColor(resources.getColor(R.color.black))
                textview_email.setTextColor(resources.getColor(R.color.black))
                textview_facebook.setTextColor(resources.getColor(R.color.black))
                textview_twitter.setTextColor(resources.getColor(R.color.black))

                but_sign_in.setTextColor(resources.getColor(R.color.white))
                but_sign_in.setBackgroundColor(resources.getColor(R.color.black))
                menu.setBackgroundColor(resources.getColor(R.color.black))

            }

        }


        readData()

        home_img2.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_inicio)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,Principal::class.java)
            startActivity(i)
            finish()
        }

        home_img3.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_accesibilidad)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,Configuracion::class.java)
            startActivity(i)
            finish()
        }

        home_img4.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_cerrarsesion)
                    mediaPlayer.start()
                }

            }
            FirebaseAuth.getInstance().signOut()
            val i = Intent(this,MisReservas::class.java)
            startActivity(i)
            finish()
        }

        val btn_modificar = findViewById<Button>(R.id.but_sign_in)
        btn_modificar.setOnClickListener {
                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    var voz = "false"
                    for (ds: DataSnapshot in it.children) {

                        if(ds.key.toString()=="dalt_mode"){
                            voz =ds.value.toString()
                        }
                    }

                    if(voz=="true"){
                        val mediaPlayer = MediaPlayer.create(this, R.raw.boton_modificardatos)
                        mediaPlayer.start()
                    }

                }
                val intento1 = Intent(this, ModificacionDatos::class.java)
                startActivity(intento1)
                finish()
            }
    }

    private fun readData() {
        auth = FirebaseAuth.getInstance()
        val uid = auth.currentUser?.uid
        println("UID de  mi perfil: " +uid)
        if (uid != null) {
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                val nombre: String = it.child("nombre").value as String
                val apellidos: String = it.child("apellidos").value as String
                val email: String = it.child("email").value as String
                val twitter: String = it.child("twitter").value as String
                val facebook: String = it.child("facebook").value as String
                val deportes: String = it.child("deportes").value as String
                tv_name.setText(nombre + " " + apellidos)
                textview_email.setText(email)
                textview_deportes.setText(deportes)
                textview_twitter.setText(twitter)
                textview_facebook.setText(facebook)

            }
        }
    }


}