package com.example.tfg_bueno

import android.content.Intent
import android.media.MediaPlayer
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.DatabaseReference
import com.google.firebase.database.FirebaseDatabase
import kotlinx.android.synthetic.main.activity_mis_reservas.*


class MisReservas : AppCompatActivity() {

    private lateinit var database: FirebaseDatabase
    private lateinit var mDatabase: DatabaseReference
    private lateinit var auth: FirebaseAuth

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_mis_reservas)

        database = FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app/")
        mDatabase = database.getReference()
        auth = FirebaseAuth.getInstance()

        val uid = auth.currentUser?.uid

        mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
            var byw = "false"
            for (ds: DataSnapshot in it.children) {
                if (ds.key.toString() == "bw_mode") {
                    byw = ds.value.toString()
                }
            }
            if(byw=="true"){
                backgroundd.setBackgroundResource(R.drawable.background_bw)
                menu.setBackgroundColor(resources.getColor(R.color.black))

            }

        }

        home_img2.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_inicio)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,Principal::class.java)
            startActivity(i)
            finish()
        }

        home_img3.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_accesibilidad)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,Configuracion::class.java)
            startActivity(i)
            finish()
        }

        home_img4.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_cerrarsesion)
                    mediaPlayer.start()
                }

            }
            FirebaseAuth.getInstance().signOut()
            val i = Intent(this,MisReservas::class.java)
            startActivity(i)
            finish()
        }

        home_img5.setOnClickListener{
            mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                var voz = "false"
                for (ds: DataSnapshot in it.children) {

                    if(ds.key.toString()=="dalt_mode"){
                        voz =ds.value.toString()
                    }
                }

                if(voz=="true"){
                    val mediaPlayer = MediaPlayer.create(this, R.raw.boton_miperfil)
                    mediaPlayer.start()
                }

            }
            val i = Intent(this,MiPerfil::class.java)
            startActivity(i)
            finish()
        }

        setData()


    }

    private fun setData() {
        auth = FirebaseAuth.getInstance()
        val uid = auth.currentUser?.uid

        if (uid != null) {
            mDatabase.child("user").child(uid).get().addOnSuccessListener {



                val listreservas : ArrayList<Reserva> = ArrayList()
                for(ds : DataSnapshot in it.child("reservas").children) {

                    val result: Reserva = ds.getValue(Reserva::class.java)!!
                    val deporte: String = result.deporte
                    val dia: String = result.dia
                    val hora: String = result.hora
                    val pista: String = result.pista
                    val personas: String = result.personas
                    val actividad: String = result.actividad

                    val reserva = Reserva(deporte,dia,hora,pista,personas,actividad)


                    listreservas.add(reserva)

                }

                mDatabase.child("user").child(uid!!).get().addOnSuccessListener {
                    var result = "false"
                    var byw = "false"
                    var voz ="false"
                    for (ds: DataSnapshot in it.children) {

                        if (ds.key.toString() == "acc_text") {
                            result = ds.value.toString()
                        }
                        if (ds.key.toString() == "bw_mode") {
                            byw = ds.value.toString()
                        }
                        if(ds.key.toString()=="dalt_mode"){
                            voz =ds.value.toString()
                        }
                    }

                    listView.isClickable = true
                    listView.adapter = Myadapter(this, listreservas, result, byw, voz)
                    listView.setOnItemClickListener { parent, view, position, id ->

                        val deporte = listreservas[position].deporte
                        val dia = listreservas[position].dia
                        val hora = listreservas[position].hora
                        val pista = listreservas[position].pista
                        val personas = listreservas[position].personas
                        val actividad = listreservas[position].actividad


                        val i = Intent(this, DetallesReservas::class.java)
                        i.putExtra("deporte", deporte)
                        i.putExtra("dia", dia)
                        i.putExtra("hora", hora)
                        i.putExtra("pista", pista)
                        i.putExtra("personas", personas)
                        i.putExtra("actividad", actividad)

                        if(voz=="true"){
                            val mediaPlayer = MediaPlayer.create(this, R.raw.reserva)
                            mediaPlayer.start()
                        }
                        startActivity(i)
                        finish()

                    }
                }
            }
        }
    }
}