package com.example.tfg_bueno

import android.content.Intent
import android.media.MediaPlayer
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Patterns
import android.widget.Toast
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.auth.FirebaseUser
import kotlinx.android.synthetic.main.activity_sign_in.*


class SignIn : AppCompatActivity() {

    private lateinit var auth: FirebaseAuth

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_sign_in)
        auth = FirebaseAuth.getInstance()

        val voz = intent.getStringExtra("voz")


        but_sign_in.setOnClickListener {
            if(intent.getStringExtra("voz")=="true"){
                val mediaPlayer = MediaPlayer.create(this, R.raw.boton_iniciarsesion)
                mediaPlayer.start()
            }
            doLogin()

        }

        button2.setOnClickListener {
            if(intent.getStringExtra("voz")=="true"){
                val mediaPlayer = MediaPlayer.create(this, R.raw.boton_cancelar)
                mediaPlayer.start()
            }
            val i = Intent(this, MainActivity::class.java)

            val byw = intent.getStringExtra("byw")
            val tamany = intent.getStringExtra("tamany")
            val voz = intent.getStringExtra("voz")

            i.putExtra("tamany", tamany)
            i.putExtra("byw", byw)
            i.putExtra("voz", voz)

            startActivity(i)
            finish()
        }

        textView2.setOnClickListener{
            if(intent.getStringExtra("voz")=="true"){
                val mediaPlayer = MediaPlayer.create(this, R.raw.boton_registrar)
                mediaPlayer.start()
            }
            val i = Intent(this, SignUp::class.java)

            val byw = intent.getStringExtra("byw")
            val tamany = intent.getStringExtra("tamany")
            val voz = intent.getStringExtra("voz")

            i.putExtra("tamany", tamany)
            i.putExtra("byw", byw)
            i.putExtra("voz", voz)

            startActivity(i)
            finish()
        }

        editTextTextPersonName4.setOnFocusChangeListener { view, b ->
        if(intent.getStringExtra("voz")=="true"&& b){
                val mediaPlayer = MediaPlayer.create(this, R.raw.intro_email)
                mediaPlayer.start()
            }
        }

        editTextTextPassword.setOnFocusChangeListener { view, b ->
        if(intent.getStringExtra("voz")=="true"&& b){
                val mediaPlayer = MediaPlayer.create(this, R.raw.intro_contrasena)
                mediaPlayer.start()
            }
        }

        val byw = intent.getStringExtra("byw")
        val tamany = intent.getStringExtra("tamany")

        if(tamany=="false"){

            textView2.textSize=15F
            but_sign_in.textSize=15F
            button2.textSize=15F


        }else{
            textView2.textSize=23F
            but_sign_in.textSize=23F
            button2.textSize=23F

        }
        if(byw=="true"){

            backgroundd.setBackgroundResource(R.drawable.background_bw)

            textView2.setTextColor(resources.getColor(R.color.black))
            but_sign_in.setTextColor(resources.getColor(R.color.white))
            button2.setTextColor(resources.getColor(R.color.black))

            but_sign_in.setBackgroundColor(resources.getColor(R.color.black))
            button2.setBackgroundColor(resources.getColor(R.color.white))
        }

    }

    public override fun onStart(){
        super.onStart()
        val currentUser = auth.currentUser
        updateUI(currentUser)
    }

    private fun updateUI(currentUser: FirebaseUser?) {

        if (currentUser != null) {
            if(currentUser.isEmailVerified) {
                startActivity(Intent(this, Principal::class.java))
                finish()
            }else{
                Toast.makeText(
                    baseContext, "Porfavor verifique su correo.",
                    Toast.LENGTH_SHORT
                ).show()
            }
        } else {
            Toast.makeText(
                baseContext, "Fallo al iniciar sesión.",
                Toast.LENGTH_SHORT
            ).show()
        }
    }


    private fun doLogin() {
        if (editTextTextPersonName4.text.toString().isEmpty()) {
            editTextTextPersonName4.error = "Introduzca un correo"
            editTextTextPersonName4.requestFocus()
            return
        }

        if (!Patterns.EMAIL_ADDRESS.matcher(editTextTextPersonName4.text.toString()).matches()) {
            editTextTextPersonName4.error = "Introduzca un correo válido"
            editTextTextPersonName4.requestFocus()
            return
        }

        if (editTextTextPassword.text.toString().isEmpty()) {
            editTextTextPassword.error = "Introduzca una contraseña"
            editTextTextPassword.requestFocus()
            return
        }

        auth.signInWithEmailAndPassword(editTextTextPersonName4.text.toString(), editTextTextPassword.text.toString())
            .addOnCompleteListener(this) { task ->
                if (task.isSuccessful) {
                    val user = auth.currentUser
                    updateUI(user)
                } else {

                    updateUI(null)
                }
            }
    }


}