package com.example.tfg_bueno

import android.content.Intent
import android.media.MediaPlayer
import androidx.appcompat.app.AppCompatActivity
import android.os.Bundle
import android.util.Patterns
import android.util.TypedValue
import android.widget.Button
import android.widget.Toast
import com.google.firebase.auth.FirebaseAuth
import com.google.firebase.auth.FirebaseUser
import com.google.firebase.database.DataSnapshot
import com.google.firebase.database.FirebaseDatabase
import com.google.firebase.database.DatabaseReference
import kotlinx.android.synthetic.main.activity_signup.*



class SignUp : AppCompatActivity() {


    private lateinit var database: FirebaseDatabase
    private lateinit var mDatabase: DatabaseReference
    private lateinit var auth: FirebaseAuth
    private lateinit var nombre: String
    private lateinit var apellidos: String
    private lateinit var email: String
    private lateinit var nacimiento: String
    private lateinit var usuario: String
    private lateinit var contraseña: String
    private lateinit var telefono: String
    private lateinit var user: User

    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        setContentView(R.layout.activity_signup)
        auth = FirebaseAuth.getInstance()
        database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
        mDatabase = database.getReference()

        val byw = intent.getStringExtra("byw")
        val tamany = intent.getStringExtra("tamany")
        val voz = intent.getStringExtra("voz")

        if(tamany=="false"){

            textView.textSize=15F
            but_sign_in.textSize=15F
            button2.textSize=15F


        }else{
            textView.textSize=23F
            but_sign_in.textSize=23F
            button2.textSize=23F

        }
        if(byw=="true"){

            backgroundd.setBackgroundResource(R.drawable.background_bw)

            textView.setTextColor(resources.getColor(R.color.black))
            but_sign_in.setTextColor(resources.getColor(R.color.white))
            button2.setTextColor(resources.getColor(R.color.black))

            but_sign_in.setBackgroundColor(resources.getColor(R.color.black))
            button2.setBackgroundColor(resources.getColor(R.color.white))
        }


        but_sign_in.setOnClickListener {
            if(intent.getStringExtra("voz")=="true"){
                val mediaPlayer = MediaPlayer.create(this, R.raw.boton_registrar)
                mediaPlayer.start()
            }
            nombre = editTextTextPersonName.text.toString()
            apellidos = editTextTextPersonName2.text.toString()
            email = editTextTextEmailAddress.text.toString()
            nacimiento = editTextDate.text.toString()
            usuario = editTextTextPersonName4.text.toString()
            contraseña = editTextTextPassword.text.toString()
            telefono = editTextPhone.text.toString()
            user = User(nombre,apellidos,email,nacimiento,usuario,contraseña,telefono)

            signUpUser()
        }

        val boton_cancelar = findViewById<Button>(R.id.button2)
        boton_cancelar.setOnClickListener {
            if(intent.getStringExtra("voz")=="true"){
                val mediaPlayer = MediaPlayer.create(this, R.raw.boton_cancelar)
                mediaPlayer.start()
            }
            val i = Intent(this, MainActivity::class.java)

            val byw = intent.getStringExtra("byw")
            val tamany = intent.getStringExtra("tamany")
            val voz = intent.getStringExtra("voz")

            i.putExtra("tamany", tamany)
            i.putExtra("byw", byw)
            i.putExtra("voz", voz)

            startActivity(i)
            finish()
        }

        database= FirebaseDatabase.getInstance("https://tfg-ub-default-rtdb.europe-west1.firebasedatabase.app")
        mDatabase = database.getReference()
        auth = FirebaseAuth.getInstance()

        val uid = auth.currentUser?.uid


        editTextTextPersonName.setOnFocusChangeListener { view, b ->
        if(intent.getStringExtra("voz")=="true"&& b){
                val mediaPlayer = MediaPlayer.create(this, R.raw.intro_nombre)
                mediaPlayer.start()
            }
        }

        editTextTextPersonName2.setOnFocusChangeListener { view, b ->
        if(intent.getStringExtra("voz")=="true"&& b){
                val mediaPlayer = MediaPlayer.create(this, R.raw.intro_apellidos)
                mediaPlayer.start()
            }
        }

        editTextTextEmailAddress.setOnFocusChangeListener { view, b ->
        if(intent.getStringExtra("voz")=="true"&& b){
                val mediaPlayer = MediaPlayer.create(this, R.raw.intro_email)
                mediaPlayer.start()
            }
        }

        editTextDate.setOnFocusChangeListener { view, b ->
            if(intent.getStringExtra("voz")=="true"&& b){
                val mediaPlayer = MediaPlayer.create(this, R.raw.intro_fechanacimiento)
                mediaPlayer.start()
            }
        }

        editTextTextPersonName4.setOnFocusChangeListener { view, b ->
        if(intent.getStringExtra("voz")=="true"&& b){
                val mediaPlayer = MediaPlayer.create(this, R.raw.intro_usuario)
                mediaPlayer.start()
            }
        }

        editTextPhone.setOnFocusChangeListener { view, b ->
        if(intent.getStringExtra("voz")=="true"&& b){
                val mediaPlayer = MediaPlayer.create(this, R.raw.intro_tlf)
                mediaPlayer.start()
            }
        }

        editTextTextPassword.setOnFocusChangeListener { view, b ->
        if(intent.getStringExtra("voz")=="true"&& b){
                val mediaPlayer = MediaPlayer.create(this, R.raw.intro_contrasena)
                mediaPlayer.start()
            }
        }

    }

    private fun signUpUser(){
        if (editTextTextEmailAddress.text.toString().isEmpty()) {
            editTextTextEmailAddress.error = "Porfavor introduzca un email"
            editTextTextEmailAddress.requestFocus()
            return
        }

        if (editTextTextPersonName.text.toString().isEmpty()) {
            editTextTextPersonName.error = "Porfavor introduzca un nombre"
            editTextTextPersonName.requestFocus()
            return
        }

        if (editTextTextPersonName.text.toString().equals("Nombre")) {
            editTextTextPersonName.error = "Porfavor introduzca un nombre válido"
            editTextTextPersonName.requestFocus()
            return
        }

        if (editTextTextPersonName2.text.toString().isEmpty()) {
            editTextTextPersonName2.error = "Porfavor introduzca un o varios apellidos"
            editTextTextPersonName2.requestFocus()
            return
        }

        if (editTextTextPersonName2.text.toString().equals("Apellidos")) {
            editTextTextPersonName2.error = "Porfavor introduzca un o varios apellidos validos"
            editTextTextPersonName2.requestFocus()
            return
        }

        if (editTextDate.text.toString().isEmpty()) {
            editTextDate.error = "Porfavor introduzca una fecha"
            editTextDate.requestFocus()
            return
        }

        if (editTextDate.text.toString().equals("Fecha de nacimiento")) {
            editTextDate.error = "Porfavor introduzca una fecha de nacimiento válida"
            editTextDate.requestFocus()
            return
        }

        if (editTextTextPersonName4.text.toString().isEmpty()) {
            editTextTextPersonName4.error = "Porfavor introduzca un nombre de usuario"
            editTextTextPersonName4.requestFocus()
            return
        }

        if (editTextTextPersonName4.text.toString().equals("Nombre de usuario")) {
            editTextTextPersonName4.error = "Porfavor introduzca un nombre de usuario válido"
            editTextTextPersonName4.requestFocus()
            return
        }

        if (editTextPhone.text.toString().isEmpty()) {
            editTextPhone.error = "Porfavor introduzca un telefono"
            editTextPhone.requestFocus()
            return
        }

        if (editTextPhone.text.toString().equals("Número de teléfono")) {
            editTextPhone.error = "Porfavor introduzca un telefono válido"
            editTextPhone.requestFocus()
            return
        }


        if (!Patterns.EMAIL_ADDRESS.matcher(editTextTextEmailAddress.text.toString()).matches()) {
            editTextTextEmailAddress.error = "Porfavor introduzca un email válido"
            editTextTextEmailAddress.requestFocus()
            return
        }

        if (editTextTextPassword.text.toString().isEmpty()) {
            editTextTextPassword.error = "Introduzca una contraseña"
            editTextTextPassword.requestFocus()
            return
        }
        auth.createUserWithEmailAndPassword(editTextTextEmailAddress.text.toString(), editTextTextPassword.text.toString())
            .addOnCompleteListener(this) { task ->
                if (task.isSuccessful) {
                    val useraux: FirebaseUser? = auth.currentUser
                    useraux?.sendEmailVerification()
                        ?.addOnCompleteListener { task ->
                            if (task.isSuccessful) {
                                updateUI(useraux)
                                finish()
                            }
                        }
                } else {
                    Toast.makeText(baseContext, task.exception.toString(),
                        Toast.LENGTH_SHORT).show()
                }
            }

    }

    private fun updateUI(currentuser: FirebaseUser){


        //HARDCODE PARA AÑADIR ACTIVIDADES A LA BASE DE DATOS
        //mDatabase.child("reservas").setValue(reservas)

        val byw = intent.getStringExtra("byw")
        val tamany = intent.getStringExtra("tamany")
        val voz = intent.getStringExtra("voz")

        val uid = currentuser.uid
        mDatabase.child("user").child(uid!!).setValue(user)
        mDatabase.child("user").child(uid!!).child("acc_text").setValue(tamany)
        mDatabase.child("user").child(uid!!).child("bw_mode").setValue(byw)

        val i = Intent(this, SignIn::class.java)

        i.putExtra("tamany", tamany)
        i.putExtra("byw", byw)
        i.putExtra("voz",voz)

        startActivity(i)
    }
}

